#include <iostream.h>          //Prog7.6

//Forward declaration for class Display used for reference

class Display;

class Gyro {

public:

  virtual void display(Display&);

};

//

class ElevationGyro : public Gyro {       //Inherit base class Gyro

public:

  void display(Display&);
  
};

//

//Class Display declared below is not a derived class.

//It contains friend function.

//

class Display {

  int k;

public:

	friend virtual void Gyro::display(Display&);
	
    friend void ElevationGyro::display(Display&);

	Display() { k = 100; }

};

//

//Out-of-line function prototype definition

void Gyro::display(Display &obj) {

  cout << "Gyro::virtual display(Display &obj) operation envoked." << endl;

  cout    << "This should not be displayed." << endl;

}
  
//

void ElevationGyro::display(Display &obj) {

	cout << "ElevationGyro::virtual display(Display &obj) operation envoked." << endl;

	cout << "Overriding function definition; therefore, this should be displayed."

		<< endl;

	cout << "k = " << obj.k << endl;

}

//
//

void main() {

//Compiler generated constructor used

  ElevationGyro deriv;     //Derived class ElevationGyro instantiated

//Default constructor used

  Display friend_obj;

//Pointer base_ptr to base class Gyro is assigned the 

//address of deriv, an object of derived class type ElevationGyro

  Gyro *base_ptr = &deriv;

//Base Class Gyro operation called

  base_ptr -> display(friend_obj);

}


 

    
