template< class Type >        //Prog8.1

class ArincTxBuffer {

public:

	ArincTxBuffer(int lower_index, int upper_index);

	ArincTxBuffer(const ArincTxBuffer&);   // Copy constructor

	ArincTxBuffer& operator = (const ArincTxBuffer&); // Defines assignment operator =

	void insert(int index, const Type&); // Store value at index

	Type fetch(int index) const;  // Fetch value from index

	bool check_index(int index) const;  // Check index within the bounds of buffer

	~ArincTxBuffer();  // Destructor

private:

	Type* buffer;

	int high;

	int low;

	void copy_elements(const ArincTxBuffer&);   // Elementwise copy

};

