#ifndef Link_h            //Prog8.6   Link.h

#define Link_h 1


//#include "types.h"



template <class Type>

class Link
 
{

  
  public:

    
      //	This constructor shall initialize the_object_reference
      //	to object_ref.

      Link (Type *object_ref);



      //	This operation returns previous.

      Link<Type> * get_previous ();



      //	This operation sets previous.

      void set_previous (const Link<Type> *p);


      
      //	This operation returns next.

      Link <Type>* get_next ();


      
      //	This operation sets next.

      void set_next (const Link <Type>* n);


      
      //	This operation returns the_object_reference

      const Type * get_the_object_reference ();


    
 
  private:

    // Data Members for Class Attributes


      
      //	This attribute is the object being linked.

      
      Type *the_object_reference;

      
    
      Link <Type> *previous;

	  Link <Type> *next;

      
};



// Parameterized Class Link 


template <class Type>

inline Link<Type> * Link<Type>::get_previous ()

{ 
	
   return previous;
   
}


template <class Type>

inline void Link<Type>::set_previous (const Link<Type> *p)

{

   previous = (Link<Type> *)p;

}


template <class Type>

inline Link <Type>* Link<Type>::get_next ()

{

   return next;

}


template <class Type>

inline void Link<Type>::set_next (const Link <Type>* n)

{

   next = (Link<Type> *)n;

}


template <class Type>

inline const Type * Link<Type>::get_the_object_reference ()

{

   return (const Type*)the_object_reference;

}



#endif
