#include "LinkedListIterator.h"    //Prog 8.6
                                   //LinkedListIterator.cpp

 
template <class Type>

LinkedListIterator<Type>::LinkedListIterator (const LinkedList<Type> *list)

	: the_linked_list((LinkedList<Type>*)list)

{

   to_first();

}



template <class Type>

Link<Type> * LinkedListIterator<Type>::next ()

{

	current = (Link<Type> *) current->get_next();

	return current;

}

template <class Type>

Link <Type>* LinkedListIterator<Type>::previous ()

{

	current = (Link<Type> *) current->get_previous();

	return current;

}

template <class Type>

Link <Type>* LinkedListIterator<Type>::to_first ()

{

	current = the_linked_list->first();

	return current;

}


template <class Type>

Link<Type> * LinkedListIterator<Type>::to_last ()

{

	current = the_linked_list->last();

	return current;

}


template <class Type>

Link <Type>* LinkedListIterator<Type>::get_current ()

{

   return current;

}
