#include <iostream.h>            //Prog8.6    main.cpp

#include <string.h>

#include "Link.cpp"

#include "LinkedList.cpp"

#include "LinkedListIterator.cpp"

#include "Fault.h"

void main() {
	
	      LinkedList<char> theLinkedList;  //Instantiate Linked List

			
	      char a = 'A';

          Link<char> theLink1_char(&a);    //Instantiate Link

		  theLinkedList.append(&theLink1_char); 

	      char b = 'R';

		  Link<char> theLink2_char(&b);   //Instantiate Link

		  theLinkedList.append(&theLink2_char);

	      char c = 'I';

		  Link<char> theLink3_char(&c);   //Instantiate Link

		  theLinkedList.append(&theLink3_char);
		  
	      char d = 'Z';

		  Link<char> theLink4_char(&d);    //Instantiate Link

		  theLinkedList.append(&theLink4_char);

	      char e = 'O';

		  Link<char> theLink5_char(&e);   //Instantiate Link

		  theLinkedList.append(&theLink5_char);

	      char f = 'N';

		  Link<char> theLink6_char(&f);   //Instantiate Link

		  theLinkedList.append(&theLink6_char);

	      char g = 'A';

	      Link<char> theLink7_char(&g);   //Instantiate Link

		  theLinkedList.append(&theLink7_char);

          LinkedListIterator<char> theLinkedListIterator(&theLinkedList);

		  //Pointers 'prnt'  and  'pr' will be repeatedly used to retrieve
		  //objects of type   'Link'   and   'char'. Put them in block
		  //scope so that they get automatically destroyed upon exited
		  //the block. This allows repeated reuse of identifiers   'prnt'
		  //and    'pr' 

		  {

		    Link<char>* prnt = theLinkedListIterator.to_first();

		    const char* pr = prnt->get_the_object_reference();

		    cout << *pr << endl;

		  }

		  {

			  Link<char>* prnt = theLinkedListIterator.next();

		      const char* pr = prnt->get_the_object_reference();

		      cout << *pr << endl;

		  }


          {

		    Link<char>* prnt = theLinkedListIterator.next();

		    const char* pr = prnt->get_the_object_reference();

		    cout << *pr << endl;

		  }

		  {

			  Link<char>* prnt = theLinkedListIterator.next();

		      const char* pr = prnt->get_the_object_reference();

		      cout << *pr << endl;

		  }

		  {

		    //Retrieve pointer prnt to a Link object from LinkedList
		    //object using LinkedListIterator object

		    Link<char>* prnt = theLinkedListIterator.next();

			//prnt is a pointer, so class member is accessed 
			//through ->

		    const char* pr = prnt->get_the_object_reference();
			
		    cout << *pr << endl;
			
		  }

		  {

			  Link<char>* prnt = theLinkedListIterator.next();

		      const char* pr = prnt->get_the_object_reference();

		      cout << *pr << endl;

		  }

		  {

			  Link<char>* prnt = theLinkedListIterator.next();

		      const char* pr = prnt->get_the_object_reference();

		      cout << *pr << endl;

		  }

}



        //theStandardQueue1_char.add_element(a);
        //theStandardQueue1_char.add_element(b);
        //theStandardQueue1_char.add_element(c);
        //theStandardQueue1_char.add_element(d);
        //theStandardQueue1_char.add_element(e);
        //theStandardQueue1_char.add_element(f);
        //theStandardQueue1_char.add_element(g);
    	//cout << "Size of the list = " << theStandardQueue1_char.get_size_in_bytes()
		//	 << endl;
        //char aa;
        //for ( int i = 0; i < 7; ++i ) {
	        //theStandardQueue1_char.remove_element(aa);
	        //cout << aa <<endl;
		//}
//	}  // Destructor ~StandardQueue called automatically.
    
	   // StandardQueue<Fault> theStandardQueue1_Fault(5);    
        //cout << "\n\nSize of theStandardQueue1_Fault = " 
		   //  << theStandardQueue1_Fault.get_size_in_bytes() << endl;
	    //Fault theSingle("Single Line to Earth Fault");
	    //theSingle.display();
	    //theStandardQueue1_Fault.add_element(theSingle);
   	    //Fault theDouble("Double Line to Earth Fault");
        //theStandardQueue1_Fault.add_element(theDouble);
	    //Fault theSingleOpen("Single Line Open Fault");
        //theStandardQueue1_Fault.add_element(theSingleOpen);
        //Fault the4thFault("4th Fault");
        //theStandardQueue1_Fault.add_element(the4thFault);
        //Fault the5thFault("5th Fault");
        //theStandardQueue1_Fault.add_element(the5thFault);
        //Fault the6thFault("6th Fault");
        //if ( theStandardQueue1_Fault.add_element(the6thFault) )
             //cout << "\n\nThe 6th element successfully added in the queue\n" << endl;
        //else cout << "\n\nUnable to add the  6th element\n" << endl;
		//if ( theStandardQueue1_Fault.add_element_overwrite(the6thFault) )
             //cout << "\nThe 6th element successfully OVERWRITTEN the oldest data"  
			 //<< " in the queue\n\n" << endl;
        //else cout << "\nUnable to OVERWRITE the oldest data with"
//			      << " the 6th element\n\n" << endl;
		//Fault aa;
		//for ( int i = 0; i < 6; ++i ) {
		//cout << "Retrieving fault name from list     ";
	    //theStandardQueue1_Fault.remove_element(aa);
	    //aa.display();
		//}
        //theStandardQueue1_Fault.purge();
		//cout << "\n\nOperation purge() has been called" << endl;
		//cout << endl << endl;
        //for ( i = 0; i < 6; ++i ) {
		//cout << "Retrieving fault name from list     ";
	    //theStandardQueue1_Fault.remove_element(aa);
	    //aa.display();
		//}   

