#include <iostream.h>          //Prog3.3

class FuelSystem {

//Attribute private by default

  double wf_cmd, grv_at_max, grv_at_95;

public:

//Constr 1 -- default

   FuelSystem( double = 1.1, double = 2.2, double = 3.3);

//constr 2 

   FuelSystem(int, int, int);

//Contsr 3

   FuelSystem(long);

//Constr 4 -- Copy constructor

   FuelSystem(FuelSystem& );
   
	 void display() {

		 cout << "wf_cmd = " << wf_cmd << "     grv_at_max = " 
			 
			  << grv_at_max << "     grv_at_95 = " 

			  << grv_at_95 << endl;

	 }
	 
};

//

FuelSystem::FuelSystem(double x, double y, double z) {

  wf_cmd = x;

  grv_at_max = y;

  grv_at_95 = z;

}

//

FuelSystem::FuelSystem(int x, int y, int z) {

  wf_cmd = (double)x;

  grv_at_max = (double)y;

  grv_at_95 = (double)z;

}

//

FuelSystem::FuelSystem(long x ) {

  wf_cmd = grv_at_max = grv_at_95 = int(x);

}

//

FuelSystem::FuelSystem(FuelSystem& obj) {

  wf_cmd = obj.wf_cmd;

  grv_at_max = obj.grv_at_max;

  grv_at_95 = obj.grv_at_95;

}

void main() {

//Default constructor with all three default arguments -- Constr 1

  FuelSystem fuelsystem_1;
  
  fuelsystem_1.display();

//Default constructor with two default argements -- Constr 1

   FuelSystem fuelsystem_2(3.3);

   fuelsystem_2.display();

//Default constructor with one default argument -- Constr 1

   FuelSystem fuelsystem_3(4.5, 6.8);
   
   fuelsystem_3.display();

//Constructor 2 with values specified for all three arguments

    FuelSystem fuelsystem_4(7, 6, 5);    //Same type conversion as above

    fuelsystem_4.display();
	
//Constructor 3 with long integer argument

    FuelSystem fuelsystem_5(67L);

    fuelsystem_5.display();

//Constructor 4 - Copy constructor

    FuelSystem fuelsystem_6 = fuelsystem_5;

    fuelsystem_6.display();

}
