#include "N1shed.h"             //Prog3.4   File: N1shed.cpp

//Instantiate object theN1Scheduler of type class N1Scheduler

//This is peculiar to AES digital electronic engine control (DEEC)

//software

//

N1Scheduler theN1Scheduler;  //Default constructor invoked

//

N1Scheduler::N1Scheduler():     //Default constructor definition

     update_rate(0.100),

     tko_Filter(1.0, update_rate, Filter::INIT_HOLD),

     clm_Filter(update_rate, Filter::INIT_ZERO),

     cru_Filter(0.8, 15),

     dct_Filter(5.0, 0.4, 10) {}   //Initializer list used -- empty function body


double N1Scheduler::getN1Tko() {

	itsN1Tko = tko_Filter.constant1;

	return itsN1Tko;

}

//

double N1Scheduler::getN1Clm() {

	itsN1Clm = clm_Filter.output;

	return itsN1Clm;

}

//


double N1Scheduler::getN1Cru() {

	itsN1Cru = cru_Filter.constant2;

	return itsN1Cru;

}

//

double N1Scheduler::getN1Dct() {

	itsN1Dct = dct_Filter.filter_1;

	return itsN1Dct;

}

