#include <iostream.h>          //Prog4.10

#include <string.h>

enum { OPEN, CLOSED };

class Operator;

class Valve {

private:

	char name[30];

    bool valve_status;

	Operator *theOperator;

public:

	void set_name(char* string) {

		strcpy(name, string);

		valve_status = OPEN;

	}

	char* get_name() { return name; }

	void set_valve_status (bool status) { valve_status = status; }

	bool get_valve_status() { return valve_status; }

	void set_theOperator(Operator* ptr) { theOperator = ptr; }

    Operator* get_theOperator() { return theOperator; }

	char* get_operator_name(); //Unable to define in-line because
	
	                           //class Operator has not yet been declared

};

//

class Operator {

private:

	char name[30];

	Valve *theValve;

public:
	
    void set_theValve(Valve* ptr) { theValve = ptr; }

    Valve* get_theValve() { return theValve; }

	void set_name(char* string) {

		strcpy(name, string);

	}

	char* get_name() {return name; }

	void close_valve() {theValve -> set_valve_status(CLOSED); }

	bool get_valve_status() { return theValve -> get_valve_status(); }

};

//class Operator has been declared, so the following operation can be defined

char* Valve:: get_operator_name() { return theOperator -> get_name(); }



void main() {

Operator optr;

Valve valve;

optr.set_theValve( &valve );

valve.set_theOperator( &optr );

valve.set_name("Valve_1");

optr.set_name("Brian Hicks");

cout << optr.get_name() << endl;

cout << valve.get_name() << "     " << valve.get_valve_status() << endl;

optr.close_valve();

//Asking object valve to get          theOperator -> name,
 
//and object operator to get          theValve -> valve_status.

//The above illustrates inter-object communication via class association.

cout << valve.get_operator_name() << "     " << optr.get_valve_status() << endl;

}