#include <iostream.h>                 //Prog7.1

class ShapeBase {

public:

	//virtual void draw() { cout << "ShapeBase::draw() operation evoked" << endl; }

	//virtual void rotate() { cout << "ShapeBase::rotate() operation evoked" << endl; }

virtual void draw() = 0;

virtual void rotate() = 0;

};

//

class EllipseDerived : public ShapeBase {    //Inherit base class ShapeBase

public:

	void draw() { cout << "EllipseDerived::draw() operation evoked" << endl; }

	void rotate() { cout << "EllipseDerived::rotate() operation evoked" << endl; }
	
};

//

class CircleDerived : public ShapeBase {    //Inherit base class ShapeBase

public:

	void draw() { cout << "CircleDerived::draw() operation evoked" << endl; }

	void rotate() { cout << "CircleDerived::rotate() operation evoked" << endl; }
	
};

//

class SquareDerived : public ShapeBase {    //Inherit base class ShapeBase

public:

	void draw() { cout << "SquareDerived::draw() operation evoked" << endl; }

	void rotate() { cout << "SquareDerived::rotate() operation evoked" << endl; }
	
};

//

void main() {

//Compiler generated constructor used

 // ShapeBase shapebase;

  SquareDerived square;

  EllipseDerived ellipse;

  CircleDerived circle;

  //CircleDerived circle;

  ShapeBase *shape[10] = { &square, &ellipse, &circle };

  for ( int i = 0; i < 8; i++ ) {

	  if( shape[i] != 0 ) { shape[i] -> draw(); shape[i] -> rotate(); } }
  
}

 

    
