#include "Prog8_1.h"          //Prog8.1

template < class Type >

ArincTxBuffer<Type>::ArincTxBuffer(int low_index, int high_index)

               : low(low_index), high(high_index) {

	buffer = new Type[high - low + 1];

}

//

template< class Type >

void ArincTxBuffer<Type>::copy_elements(const ArincTxBuffer& a) {

	int duplicate = low;

	int original = a.low;

//	cout << "duplicate = " << duplicate << "   " << "original = " << original << endl;

	while ( duplicate <= high && original <= a.high )

	   insert(duplicate++, a.fetch( original++));

}

//

template< class Type >

ArincTxBuffer<Type>::ArincTxBuffer(const ArincTxBuffer& a)

         : low(a.low), high(a.high) {

	buffer = new Type[high - low + 1];

	copy_elements(a);

}

//

template< class Type >

ArincTxBuffer<Type>& ArincTxBuffer<Type>::operator = ( const ArincTxBuffer& a ) {

	if ( this != &a )

		copy_elements(a);

	return *this;

}

//

template< class Type >

void ArincTxBuffer<Type>::insert(int index, const Type& obj) {

	buffer[index - low] = obj;

}

//

template< class Type >

Type ArincTxBuffer<Type>::fetch( int index ) const {

	return buffer[index - low];

}

//

template< class Type >

bool ArincTxBuffer<Type>::check_index(int index) const {

	if ( index >= low && index <= high )

		return true;

	else

		return false;

}

//

template< class Type >

ArincTxBuffer<Type>::~ArincTxBuffer() {

	delete [] buffer;

	cout << "Deleted Buffer" << endl;

}


//

#include<iostream.h>

void main() {

	ArincTxBuffer<double> theArincTxBuffer1(3, 10);
	
	theArincTxBuffer1.insert(4, 4.4);

	theArincTxBuffer1.insert(5, 5.5);

	for (int i = 3; i < 11; i++) {

	cout << theArincTxBuffer1.fetch(i) << endl;
	
    }

	cout <<  endl << endl;

    ArincTxBuffer<double> theArincTxBuffer2(theArincTxBuffer1);

    for ( i = 3; i < 11; i++) {

	cout << theArincTxBuffer2.fetch(i) << endl; 

    }

	cout <<  endl << endl;

	ArincTxBuffer<double> theArincTxBuffer3(1, 10);

    for ( i = 1; i < 11; i++) {

	cout << theArincTxBuffer3.fetch(i) << endl; 

    }

    cout <<  endl << endl;

	theArincTxBuffer1.insert(7, 7.7);

	theArincTxBuffer1.insert(8, 8.8);

	theArincTxBuffer3 = theArincTxBuffer1;

    for ( i = 1; i < 11; i++) {

	    cout << theArincTxBuffer3.fetch(i) << endl;

    }

	 theArincTxBuffer1.ArincTxBuffer<double>::~ArincTxBuffer();

	 theArincTxBuffer2.ArincTxBuffer<double>::~ArincTxBuffer();

     theArincTxBuffer3.ArincTxBuffer<double>::~ArincTxBuffer(); 

}
