#include "Prog8_2.h"            //Prog8.2

template<class TYPE>

container<TYPE>::container( int size )

   {

     if ( size < 1 || size > 100) number_of_elements_in_container = 100;

     else number_of_elements_in_container = size;

     elements = new TYPE[number_of_elements_in_container];

	}


template<class TYPE>

container<TYPE>::~container()

   {

      delete elements;

	}


template<class TYPE>

int container<TYPE>::get_container_size()

   {

     return number_of_elements_in_container;

	}


 template<class TYPE>

 BOOL container<TYPE>::insert_element( int location, const TYPE elem )

 {

   if ( location < 1 || location > number_of_elements_in_container )

     return FALSE;                 // 'location' out of bounds.

// Convertion to subscript, and returning pointer to the element

   elements[location - 1] = elem;     // Cast to TYPE

   return TRUE;                    // Insertion of element is successful

 }


 template<class TYPE>

 TYPE* container<TYPE>::fetch_pointer_to_element( int location )

 {

   if ( location < 1 ||  location > number_of_elements_in_container )

     return NULL;              // 'location' out of bounds

// Convertion to subscript, and returning pointer to the element

   return &elements[location - 1];
   
 }




 void main()  {

	 container<unsigned> store = 100;   //Same as store(100).

	 unsigned* pointer_to_element;

	 int i;


	 for ( i=1; i<= store.get_container_size(); i++)  {

		 if ( !store.insert_element(i,i) )

			 cout << "Countervalue assignment failed ! \r\n";

	 }

	 pointer_to_element = store.fetch_pointer_to_element(50);  //Get 3rd item.

	 cout << "Initial value is " << *pointer_to_element << "\r\n";

	 *pointer_to_element += 400;    //Modify the value by pointer.

	 cout << "Updated value is " << *pointer_to_element << "\r\n";

 }


