                      //Prog8.3

//ArincTxBuffer template parameterized by type, and containing template arguments.

template< class Type, int LOW, int HIGH  >

class ArincTxBuffer {

public:

	void insert(int index, const Type&); // Store value at index

	Type fetch(int index) const;  // Fetch value from index

	bool check_index(int index) const;  // Check index within the bounds of the array

private:

	Type buffer[HIGH - LOW + 1];

//Default memberwise copy semantics are valid. Therefore, copy constructor and 
//assignment operator are redundant. Hence they are removed.
//void copy_elements(const ArincTxBuffer&);   // Elementwise copy
//ArincTxBuffer<Type, LOW, HIGH>& operator = ( const ArincTxBuffer& a );

};

