#include <iostream.h>            //Prog8.5

#include <string.h>

#include "StandardQueue.cpp"

#include "Fault.h"

void main() {

	{   //Block scope define to call the destructor ~StandardQueue automatically.

		StandardQueue<char> theStandardQueue1_char(100);

	    char a = 'A';

	    char b = 'R';

	    char c = 'I';

	    char d = 'Z';

	    char e = 'O';

	    char f = 'N';

	    char g = 'A';

	
        theStandardQueue1_char.add_element(a);

        theStandardQueue1_char.add_element(b);

        theStandardQueue1_char.add_element(c);

        theStandardQueue1_char.add_element(d);

        theStandardQueue1_char.add_element(e);

        theStandardQueue1_char.add_element(f);

        theStandardQueue1_char.add_element(g);

    	cout << "Size of the list = " << theStandardQueue1_char.get_size_in_bytes()

			 << endl;

        char aa;

        for ( int i = 0; i < 7; ++i ) {

	        theStandardQueue1_char.remove_element(aa);

	        cout << aa <<endl;

		}

	}  // Destructor ~StandardQueue called automatically.

    
	    StandardQueue<Fault> theStandardQueue1_Fault(5); 
		
        cout << "\n\nSize of theStandardQueue1_Fault = " 

		     << theStandardQueue1_Fault.get_size_in_bytes() << endl;

	    Fault theSingle("Single Line to Earth Fault");

	    theSingle.display();

	    theStandardQueue1_Fault.add_element(theSingle);

   	    Fault theDouble("Double Line to Earth Fault");

        theStandardQueue1_Fault.add_element(theDouble);

	    Fault theSingleOpen("Single Line Open Fault");

        theStandardQueue1_Fault.add_element(theSingleOpen);

        Fault the4thFault("4th Fault");

        theStandardQueue1_Fault.add_element(the4thFault);

        Fault the5thFault("5th Fault");

        theStandardQueue1_Fault.add_element(the5thFault);

        Fault the6thFault("6th Fault");

        if ( theStandardQueue1_Fault.add_element(the6thFault) )

             cout << "\n\nThe 6th element successfully added in the queue\n" << endl;

        else cout << "\n\nUnable to add the  6th element\n" << endl;

		if ( theStandardQueue1_Fault.add_element_overwrite(the6thFault) )

             cout << "\nThe 6th element successfully OVERWRITTEN the oldest data" 
			 
			 << " in the queue\n\n" << endl;

        else cout << "\nUnable to OVERWRITE the oldest data with"

			      << " the 6th element\n\n" << endl;

		Fault aa;

		for ( int i = 0; i < 6; ++i ) {

		cout << "Retrieving fault name from list     ";

	    theStandardQueue1_Fault.remove_element(aa);

	    aa.display();

		}

        theStandardQueue1_Fault.purge();

		cout << "\n\nOperation purge() has been called" << endl;

		cout << endl << endl;

        for ( i = 0; i < 6; ++i ) {

		cout << "Retrieving fault name from list     ";

	    theStandardQueue1_Fault.remove_element(aa);

	    aa.display();

		}
		
}
