#include "Filter.h"           //Prog3.4   File: N1shed.h

class N1Scheduler {   //Determines engine setpoints

public:

    N1Scheduler();    //Default constructor

    double getN1Tko();

	double getN1Clm();

	double getN1Cru();

	double getN1Dct();

//

//Private attributes

	double update_rate;

	double itsN1Tko;      //N1 takeoff setpoint

	double itsN1Clm;      //N1 climb setpoint

	double itsN1Cru;      //N1 cruise setpoint

	double itsN1Dct;      //N1 descent setpoint

	Filter tko_Filter;    //Filter object declared -- but not created

	Filter clm_Filter;    //   "      "      "         "   "    " 
	
	Filter cru_Filter;    //   "      "      "         "   "    "
	
	Filter dct_Filter;    //   "      "      "         "   "    "

};

extern N1Scheduler theN1Scheduler;

