#include <iostream.h>                     //Prog4.11

#include <string.h>

enum { OPEN, CLOSED };

class Operator;

class Valve {

private:

	char name[30];

	bool valve_status;

public:
	
	void set_name(char* string) {

		strcpy(name, string);
	}

	char* get_name() { return name; }

	void set_valve_status(bool status) { valve_status = status;  }

	bool get_valve_status() {return valve_status; }

	char* get_operator_name(Operator* theOperator);

};

//

class Operator {

private:

	char name[30];

public:

	void set_name(char* string) {

		strcpy(name, string);

	}

    char* get_name() { return name; }

	void close_valve( Valve* theValve) {

		theValve -> set_valve_status(CLOSED);

	}

	char* get_valve_name(Valve* theValve) { return theValve -> get_name(); }

	bool get_valve_status(Valve* theValve) { return theValve -> get_valve_status(); }

};

//

char* Valve::get_operator_name(Operator* theOperator) { 

	return theOperator -> get_name();

}

//

void main() {

   int i;

   Operator *theOperator[4];

   for ( i = 0; i < 4; ++i ) theOperator[i] = new Operator;

   theOperator[0] -> set_name("Brian Jones");

   theOperator[1] -> set_name("Bob Calvert");

   theOperator[2] -> set_name("Jimmy Logan");

   theOperator[3] -> set_name("Bal Khrishnan"); 

   Valve *theValve[4];

   for ( i = 0; i < 4; ++i ) theValve[i] = new Valve;

   theValve[0] -> set_name("Valve_1");

   theValve[1] -> set_name("Valve_2");

   theValve[2] -> set_name("Valve 3");

   theValve[3] -> set_name("Valve 4");

   for( i = 0; i<4; ++i ) theValve[i] -> set_valve_status(OPEN);

   //Valve object pointed by pointer theValve[i] is asked to get

   //name from Operator object pointed by pointer thePointer[i].

   //Operator object pointed by pointer theOperator[i] is asked to get name

   //from Valve object pointer by theValve[i].

   //Operator object pointed by pointer theOperator[i] is asked to get valve_status

   //from Valve object pointer by theValve[i].

   //What a funny way to do things !!!!!!!!. 
   
   for ( i = 0; i < 4; ++i ) {  
	   
   cout << theValve[i] -> get_operator_name(theOperator[i]) << "     "

	   << theOperator[i] -> get_valve_name(theValve[i]) << "     "

	   << "valve_status = " <<  theOperator[i] -> get_valve_status(theValve[i]) << endl;

   }

   cout << "Initialization Complete" << endl << endl <<endl;

   theOperator[2] -> close_valve(theValve[3]);

   //Here the Operator object is asked directly for its name.

   cout << theOperator[2] -> get_name() << endl;

   //Here the Valve object is asked for its name directly.

   cout << theValve[3] -> get_name() << endl; 

   //Here the Valve object is asked directly for its status.

   cout << theValve[3] -> get_valve_status() << endl;

  //Explicitly delete 4 + 4 objects created in the heap by operator new to

  //avoid memory leak.

   for( i = 0; i < 4; ++i ) {

	   delete theValve[i];

	   delete theOperator[i];

   }

}