#include <iostream.h>           //Prog5.8

class PhysicalDevice {

//Attributes private by default

  int qsm_vector_offset, tpu_vector_offset;

public:

//Default constructor

  PhysicalDevice(int x = 10,int y = 100) {

      qsm_vector_offset = x;

	  tpu_vector_offset = y;

  }

//Redefine operator =

  PhysicalDevice&   operator = (PhysicalDevice&  obj) {

    qsm_vector_offset = obj.qsm_vector_offset;

	tpu_vector_offset = obj.tpu_vector_offset;

	return *this;

  }

  void display() { cout << "PhysicalDevics base class"

	  << " attributes are:" << endl;

      cout << "qsm_vector_offset = " << qsm_vector_offset
		  
		   << "          tpu_vector_offset = " << tpu_vector_offset << endl;

  }

};

//

class PhysicalSim : public PhysicalDevice {

public:

  int configuration_register;

  int chip_select_option_register;

//Default constructor

public:

  PhysicalSim(int xa = 0, int xb = 0,

	  int xc = 100, int xd = 1000 ) :

  PhysicalDevice(xa, xb) { configuration_register = xc;

  chip_select_option_register = xd; }

//Redefine operator  =

  PhysicalSim&  operator = (PhysicalSim& deriv_obj) {

	PhysicalDevice* base_ptr;  //Pointer to base class PhysicalDevice

    configuration_register = deriv_obj.configuration_register;

    chip_select_option_register = deriv_obj.chip_select_option_register;
	
//Convert pointer ..this.. to base PhysicalDevice type

	base_ptr = (PhysicalDevice*)this;

//Next use base class PhysicalDevice operator =

	*base_ptr = deriv_obj;  //Base class PhysicalDevice data is copied
	
	return *this;

  }


void display() {

	  PhysicalDevice::display();

	  cout << "\nPhysicalSim derived class attributes are:" << endl;

	  cout << "configuration_register = " << configuration_register

	   << "     chip_select_option_register = " 

	   << chip_select_option_register << endl;

  }

};

//

void main() {

  PhysicalSim deriv_obj;

  PhysicalSim another_deriv_obj(2, 4, 8, 16);

  deriv_obj = another_deriv_obj;

  deriv_obj.display();
  
}

 

    
